// GLWnd.cpp : implementation file
//

#include "stdafx.h"
#include "GLWnd.h"
#include "SaverWnd.h"
#include "CISaver.h"


// CGLWnd

IMPLEMENT_DYNAMIC(CGLWnd, CWnd)
CGLWnd::CGLWnd()
{
 m_hRC=0;
 m_hDC=0;
 m_bHasTimer = FALSE;
}

CGLWnd::~CGLWnd()
{
}


BEGIN_MESSAGE_MAP(CGLWnd, CWnd)
	ON_WM_CREATE()
//	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_TIMER()
END_MESSAGE_MAP()



// CGLWnd message handlers
BOOL CGLWnd::SetupPixelFormat(HDC hDC )
{
    static PIXELFORMATDESCRIPTOR pfd = 
	 {
		sizeof(PIXELFORMATDESCRIPTOR),  //  size of this pfd
			1,                     // version number
			PFD_DRAW_TO_WINDOW |   // support window
			PFD_SUPPORT_OPENGL |   // support OpenGL
			PFD_DOUBLEBUFFER,      // double buffered
			PFD_TYPE_RGBA,         // RGBA type 
			24,                    // 24-bit color depth 
			0, 0, 0, 0, 0, 0,      // color bits ignored
			0,                     // no alpha buffer
			0,                     // shift bit ignored
			0,                     // no accumulation buffer
			0, 0, 0, 0,            // accum bits ignored
			32,                    // 32-bit z-buffer
			0,                     // no stencil buffer
			0,                     // no auxiliary buffer
			PFD_MAIN_PLANE,        // main layer
			0,                     // reserved
			0, 0, 0                // layer masks ignored
	 };
    int pixelformat;

    if ( (pixelformat = ChoosePixelFormat(hDC, &pfd)) == 0 )
    {
        AfxMessageBox("ChoosePixelFormat failed");
	    return FALSE;
    }

    if (SetPixelFormat(hDC, pixelformat, &pfd) == FALSE)
    {
        AfxMessageBox("SetPixelFormat failed");
	    return FALSE;
    }

    return TRUE;
}


int CGLWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	TRACE("CGLWnd::OnCreate(LPCREATESTRUCT...)\n");
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// m_pDC = GetDC();
	 m_hDC = ::GetDC(m_hWnd);			
	
	SetupPixelFormat(m_hDC);

	 m_hRC = wglCreateContext(m_hDC);
  if(m_hRC==NULL){
		AfxMessageBox("OpenGL contest fail");
		return -1;
	}
		//set timer
	if(!m_bHasTimer)
	{
		SetTimer(1, 10, NULL);
    m_bHasTimer = TRUE;
	}
	
  Invalidate();

	return 0;
}

BOOL CGLWnd::myCreate(DWORD dwExStyle, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{
	TRACE("CGLWnd::Create(DWORD...)\n");

	// Register a class with no cursor
	LPCTSTR lpszClassName= AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW,
			::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_NULL_CURSOR)));
	
	return CreateEx(dwExStyle, lpszClassName, _T(""), dwStyle, 
		   rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, 
	     pParentWnd->GetSafeHwnd(), NULL, NULL );
	
//	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//void CGLWnd::OnDestroy()
//{
//	CWnd::OnDestroy();
//
//	// TODO: Add your message handler code here
//}

void CGLWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	SetGL();
	TRACE("CGLWnd::OnPaint(s)\n");
	glPushMatrix();
	glRotatef(30*clock()/1000.0f,0,0,1);
	glClearColor(.1f,.2f,.3f,1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(1,1,1);
	glBegin(GL_LINE_LOOP);
	glVertex2f( .3f,-.3f);
	glVertex2f(-.3f,-.3f);
	glVertex2f(-.3f, .3f);
	glVertex2f( .3f, .3f);
	glEnd();
	glPopMatrix();
	SwapBuffers(m_hDC);
}


void CGLWnd::OnSize(UINT nType, int cx, int cy)
{
	TRACE("CGLWnd::OnSize()\n");
	CRect rect;

	if(SetGL()){
	glMatrixMode (GL_PROJECTION);   
	glLoadIdentity ();
	aspect=(float)cx/(float)cy;
	glViewport (0, 0, (GLsizei) cx, (GLsizei) cy); 
	}
}

//void CGLWnd::PostNcDestroy()
//{
//	// TODO: Add your specialized code here and/or call the base class
//
//	//CWnd::PostNcDestroy();
//}

void CGLWnd::OnTimer(UINT nIDEvent)
{
	TRACE("CGLWnd::OnTimer()\n");
	Invalidate();
	//CWnd::OnTimer(nIDEvent);
}
